#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "libweb/webutil.h"

/*----------------------------------------------------------------------------*/

typedef struct
{
   int r;
   int w;
}
Score;

typedef struct
{
   int low;
   int high;
   char* comment;
}
Range;

Score scores[100][10];
Range ranges[100];
int range = 0;

/*----------------------------------------------------------------------------*/

char* Comment( int n )
{
   int i;
   for( i = 0; i < 100; i++ )
      if( ranges[i].low <= n && n <= ranges[i].high )
         return( ranges[i].comment );
   return( "dunno" );
}

/*----------------------------------------------------------------------------*/

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   register int x, m = -1;
   int cl, maxtotal, total;
   char* qname = argv[1];
   char a_url[160];
   char background[160]; background[0] = 0;

   printf( "Content-type: text/html%c%c", 10, 10 );

   if( strcmp( getenv( "REQUEST_METHOD" ), "POST" ) )
   {
      printf( "This script should be referenced with a METHOD of POST.\n" );
      printf( "If you don't understand this, see this ");
      printf( "<A HREF=\"http://www.ncsa.uiuc.edu/SDG/Software/Mosaic/Docs/fill-out-forms/overview.html\">forms overview</A>.%c", 10 );
      exit( 1 );
   }
   if( strcmp( getenv("CONTENT_TYPE"), "application/x-www-form-urlencoded") )
   {
      printf( "This script can only be used to decode form results.\n" );
      exit( 1 );
   }
   cl = atoi( getenv( "CONTENT_LENGTH" ) );

   for( x = 0; cl && ( !feof( stdin ) ); x++ )
   {
      m = x;
      entries[x].val = fmakeword( stdin, '&', &cl );
      plustospace( entries[x].val);
      unescape_url( entries[x].val );
      entries[x].name = makeword( entries[x].val, '=' );
   }

   {
      FILE* fp;
      int q, o, r, /*w,*/ low, high;
      char buf1[160], buf2[80];

      sprintf( buf2, "%s/%s", ROOT, qname );
      fp = fopen( buf2, "r" );

      while( fgets( buf1, 160, fp ) )
      {
         switch( buf1[0] )
         {
            case 'o':
               /*if ( sscanf( buf1, "o %d %d %d %d", &q, &o, &r, &w ) == 4 )*/
               if ( sscanf( buf1, "o %d %d %d", &q, &o, &r ) == 3 )
               {
                  scores[q][o].r = r;
                  /*scores[q][o].w = w;*/
               }
               break;
            case 's':
               if ( sscanf( buf1, "s %d %d {%[^}]}", &low, &high, buf2 ) == 3 )
               {
                  ranges[range].low = low;
                  ranges[range].high = high;
                  ranges[range].comment = strdup( buf2 );
                  range++;
               }
               break;
/*
            case 'q':
               sscanf( buf1, "q %s", q_url );
               break;
*/
            case 'a':
               sscanf( buf1, "a %s", a_url );
               break;
            case 'b':
               sscanf( buf1, "b %s", background );
               break;
            default:
               break;
         }
      }
      for( q = 0; q < 100; q++ )
      {
         int m = -1;
         for( o = 0; o < 10; o++ )
            m = scores[q][o].r > m ? scores[q][o].r : m;
         maxtotal += m;
      }
   }

   printf( "<html>%c", 10 );
   printf( "<title>Quiz Results</title>%c", 10 );
   if( background[0] != 0 )
      printf( "<body background=\"%s\">%c", background, 10 );
   else
      printf( "<body>%c", 10 );

   total = 0;
   for( x = 0; x <= m; x++ )
   {
      if( strcmp( entries[x].name, "quiz" ) != 0 )
      {
         int q = atoi( entries[x].name );
         int o = atoi( entries[x].val );
         total += scores[q][o].r;
      }
   }
   printf( "<h2>Quiz Results</h2>%c", 10 );
   printf( "<p>You scored %d out of a maximum of %d%c", total, maxtotal, 10 );
   printf( "<p>%s%c", Comment( total ), 10 );
   printf( "<p>Here are the <a href=\"%s\">correct answers</a>%c", a_url, 10 );

   printf( "</body>%c", 10 );
   printf( "</html>%c", 10 );

   return 0;
}

/*----------------------------------------------------------------------------*/
