#
#  restaura.awk  Ver 1.0
#
#  <C> Copyright 1996 Symbiotic Solutions
#  Authors:  Emanuel Noik
#
#  This code may look like awk but it's actually gawk!
#
#-------------------------------------------------------------------------------

BEGIN {
   FS="|";		# field separator
   n = 0;		# number of hits

   print "<html><header>";
   print "<title>Toronto's WWW Restaurant Listings - Search Results</title>";
   print "</header>";
   print "<body background=\"/images/bg.jpg\">";
   print "<body>";
   print "<h2>Search Results</h2><hr>";

   dbInit();		# initialize database package
   dbMaxHits=5;		# set default maximum hits (temporary)

   dbField(1,  "S", "" )			# name
   dbField(2,  "S", "" )			# addr
   dbField(3,  "S", "" )			# landmark
   dbField(4,  "L", "restaura/neigh.txt" )	# neighbourhood
   dbField(5,  "L", "restaura/region.txt" )	# region
   dbField(6,  "L", "restaura/city.txt" )	# city
   dbField(7,  "S", "" )			# telephone
   dbField(8,  "M", "restaura/type.txt" )	# type
   dbField(9,  "L", "restaura/price.txt" )	# price
   dbField(10, "S", "" )			# Toronto Life URL

   dbArgs();

   TOR_LIFE_DB_PATH = "http://www.tor-lifeline.com/tl/restaurant-data/data";
}

function LandMark(s) {
   if( s == "" ) return "";
   else return sprintf( "<i>%s</i>, ", s );
}

function Review(s) {
   if( s == "" ) return "";
   else return sprintf( \
    " (<font size=\"-1\"><a href=\"%s/%s\">Toronto Life review</a></font>)", \
    TOR_LIFE_DB_PATH, s );
}

{
   if( NR < dbOffset ) next;	# skip records

   if( myFilter() )
   {
      if( n == dbMaxHits )		# only show dbMaxHits
      {
         dbMoreHits( "/cgi-bin/rest" );
         exit;
      }

      print "<P><B>" $1 "</B>, " $2 ", " LandMark($3) ml[6,$6] ", " $7 Review($10)
      n++;
   }
}

function myFilter() {
   return ( dbFilterI(1) > -1 && \
            dbFilterI(2) > -1 && \
            (dbFilterI(4) + dbFilterI(5)) > -1 && \
            dbFilterI(8) > -1 && \
            dbFilterI(9) > -1 \
          ) ? 1 : 0;
}

END {
   if( dbErr )
   {
      print "Received bad data from form, your browser sucks!";
   }
   else
   {
      print "<hr>";
      dbFooter();
      print "<hr>"
      print "<font size=-1><center>";
      print " <img src=\"/images/icon.gif\" alt=\"[Logo]\"><br>";
      print " Copyright &#169; 1996 <a href=\"/\">Symbiotic Solutions</a>,";
      print " <a href=\"/food/ack.html\">Acknowledgements</a>";
      print "</center></font>";
      print "</body></html>";
   }
}

#-------------------------------------------------------------------------------
