
BEGIN {
   FS = "|";
   rootpath="/u/noik/web/symsol.com"
   footer = "<p>\nToolBar\nFooter";
   header="#include \"defs.h\"\nHeader(- Database Statistics)\n<h2>Database Statistics</h2>";

   STAT_FMT = "%-28s %4d records, %4.1f%% %-s\n";

   dbField(1,  "S", "" )			# name
   dbField(2,  "S", "" )			# addr
   dbField(3,  "S", "" )			# landmark
   dbField(4,  "L", "restaura/neigh.txt" )	# neighbourhood
   dbField(5,  "L", "restaura/region.txt" )	# region
   dbField(6,  "L", "restaura/city.txt" )	# city
   dbField(7,  "S", "" )			# telephone
   dbField(8,  "M", "restaura/type.txt" )	# type
   dbField(9,  "L", "restaura/price.txt" )	# price
   dbField(10, "S", "" )			# Toronto Life URL
}


function Category(field,title,n,nitems,ntot,     i,p,b,bar) {
   print "<h3>Breakdown by " title ":</h3>\n<pre>";
   for( i = 0; i < nitems; i++ )
   {
      p = n[i] / (1.0 * ntot );
      b = p * 50.0 + 0.5;
      bar = "**************************************************";
      bar = substr(bar,1,b);
      printf( STAT_FMT, ml[field,i], n[i], 100.0 * n[i] / (1.0 * ntot), bar );
   }
   print "</pre>";
}

/*----------------------------------------------------------------------------*/

{
   nhoods[$4]++;
   regions[$5]++;
   len = split($8,a,",");
   for( i = 1; i <= len; i++ )
      types[a[i]]++;
   prices[$9]++;
   n++;
}

END {
   print header
   print "<p>Compiled on <i>" strftime("%a %h %d %r %Z %Y") "</i><hr>"
   print "<h3>Total number of records:</h3>\n<pre>" n "</pre>"

   Category( 9, "price", prices, 5, n );
   Category( 4, "neighbourhood", nhoods, 32, n );
   Category( 5, "region", regions, 5, n );
   Category( 8, "cuisine type", types, 22, n );

   print footer
}

#-------------------------------------------------------------------------------
